; Dbut du script-fu Demo_Texte_Metal_GMIC_Gimp_2_8.scm
;
; Accs par :   Fichier > Crer > Logos > G'MIC Demo. Texte Metal...
;               File > Create > Logos > G'MIC Demo. Texte Metal...
;
;
;
;
;
; Licence GNU/GPL
;
; --------------------------------------------------------------------
; dit avec Notepad++    http://notepad-plus-plus.org/
;
; version 1.0 par samj (  http://www.aljacom.com/~gimp       http://samjcreations.blogspot.com  ) 26 septembre 2012
;
; --------------------------------------------------------------------
;
;

;





(define (
				
				Demo_Texte_Metal_GMIC_Gimp
				Texte
				Police
				Taille_Police
				Couleur_texte
				Inverser_couleur_texte
				Bruit
				Couleur_contour_texte
				Inverser_couleur_contour_texte
				Epaisseur_contour
				Couleur_fond
				Inverser_couleur_fond
				flatten				

		)



		
	(let*
		(
			; affectation des variables	

			; mmoriser les couleurs PP et AP
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
			
			; mmoriser la brosse active
			(old-brush (car (gimp-context-get-brush)))	

			; mmoriser le dgrad actif
			(old_gradient (car (gimp-context-get-gradient)))

			; mmoriser le motif actif
			(old_pattern (car (gimp-context-get-pattern)))

			; mmoriser antialias
			(old_antialias (car (gimp-context-get-antialias)))

			; mmoriser sample-merged
			(old_sample-merged (car (gimp-context-get-sample-merged)))
			
			; mmoriser sample-criterion
			(old_sample-criterion (car (gimp-context-get-sample-criterion)))
			
			; mmoriser sample-transparent		
			(old_sample-transparent (car (gimp-context-get-sample-transparent)))
			
			; mmoriser sample-threshold-int
			(old_sample-threshold-int (car (gimp-context-get-sample-threshold-int)))

			; mmoriser l'interpolation
			(old_interpolation (car (gimp-context-get-interpolation)))
			
			

			; caractristiques de la surface occupe par le texte
			(fond_texte)

			; largeur de la future image
			(width) 
			
			; hauteur de la future image
			(height) 
			
			; crer une nouvelle image rgb
			(img)
			
			; calques texte
			(calque_texte)
			
			; calques contour texte
			(calque_contour_texte)

			; calques fond
			(calque_fond)
		
		)

	; vrification texte vide
	(if (= (string-length Texte) 0)
		(set! Texte "GIMP & GMIC")
	)

	
	
	
	; contexte
	(gimp-context-set-feather FALSE)
	
	(gimp-context-set-feather-radius 
		1									; feather-radius-x 
		1									; feather-radius-y
	)
	
	(gimp-context-set-antialias TRUE)

	(gimp-context-set-sample-merged TRUE)
	
	(gimp-context-set-sample-criterion 0) ;  (0 <= sample-threshold <= 1)
	
	(gimp-context-set-sample-transparent TRUE)
	
	(gimp-context-set-sample-threshold-int 1)
	
	(gimp-context-set-interpolation 2) ; interpolation cubique
	
	
	
	


	; caractristiques de la surface occupe par le texte
	(set! fond_texte (gimp-text-get-extents-fontname Texte Taille_Police 0 Police))

	; largeur de la future image
	(set! width (car fond_texte)) 
	
	; hauteur de la future image
	(set! height (cadr fond_texte)) 
	
	; crer une nouvelle image rgb
	(set! img (car (gimp-image-new (+ width height) (+ width height) 0)))	
	

		
	;; Start undo group.
	(gimp-image-undo-group-start img)	




	

; calque Texte *******************************************************************************	

	; choisir pp
	(gimp-context-set-foreground Couleur_texte)

	; couleur d'arrire plan
	(gimp-context-set-background '(255 255 255))
	
	; crer le calque texte
	;                      (gimp-text-fontname image drawable x y text border antialias size size-type fontname)
	(set! calque_texte (car (gimp-text-fontname img -1 (/ height 2) (/ width 2) Texte 0 FALSE Taille_Police 0 Police)))

	; donner un nom au calque
	(gimp-item-set-name calque_texte "Texte")
	
	; calque texte aux dimensions de l'image
	(gimp-layer-resize-to-image-size calque_texte)
	
	; inversion des couleurs (logos lettres couleurs inverses)
	(if
		(= Inverser_couleur_texte TRUE)
			(gimp-invert calque_texte)
	)
	
	; contenu vers slection , existe-t-il un quivalent pour Gimp 2.8 ???
	(gimp-selection-layer-alpha calque_texte)
	
	; appel de G'MIC et positionnement variable
	(set! Bruit (round Bruit))
	
	(plug-in-gmic 1 img calque_texte 1
		(string-append
			"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
			"-gimp_noise "
			(number->string Bruit 10) ",0,7,0 -gimp_local_orientation 0,0,100,0,7 -gimp_normalize_local 0,6,5,20,1,0"
		)
	)	
	
	

	; agrandir slection
	(gimp-selection-grow img Epaisseur_contour)

	
; calque_contour_texte*********************************************************************************
	

	; crer calque_contour_texte
	(set! calque_contour_texte (car (gimp-layer-new img (+ width height) (+ width height) 1 "calque_contour_texte" 100 0)))	
	
	; ajouter le calque calque_contour_texte
	(gimp-image-insert-layer img calque_contour_texte 0 -1)

	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_contour_texte)
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background '(255 255 255))

	; remplir de PP	
	;(gimp-drawable-fill calque_contour_texte 0)

	; remplir la slection
	(gimp-edit-bucket-fill calque_contour_texte 0 0 100 0 TRUE 0 0)
	
	; inversion des couleurs (logos lettres couleurs inverses)
	(if
		(= Inverser_couleur_contour_texte TRUE)
			(gimp-invert calque_contour_texte)
	)
	
	; ne rien slectionner
	(gimp-selection-none img)	
	
	

; calque_fond*********************************************************************************
	

	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new img (+ width height) (+ width height) 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer img calque_fond 0 -1)

	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_fond)
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background '(255 255 255))

	; remplir de PP	
	(gimp-drawable-fill calque_fond 0)
	
	; inversion des couleurs (logos lettres couleurs inverses)
	(if
		(= Inverser_couleur_fond TRUE)
			(gimp-invert calque_fond)
	)

	; appel de G'MIC et positionnement variable
	(set! Bruit (round Bruit))
	
	(plug-in-gmic 1 img calque_fond 1
		(string-append
			"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
			"-gimp_noise "
			(number->string Bruit 10) ",0,7,0 -gimp_local_orientation 0,0,100,0,7 -gimp_normalize_local 0,6,5,20,1,0"
		)
	)	
	
	
; mettre en place les calques ****************************************************************

	(gimp-image-lower-item-to-bottom img calque_contour_texte)
	(gimp-image-lower-item-to-bottom img calque_fond)
	



	
;*******************************************************************************************
	
	; aplatir l'image
	(if
		(= flatten TRUE)
			(gimp-image-flatten img)
	)	
	
	
	
;*****************************************************************************************	
	
	
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg)
	(gimp-context-set-background old-bg)
	
	; restaurer ancien dgrad
	(gimp-context-set-gradient old_gradient)
	
	; restaurer brosse
	(gimp-context-set-brush old-brush)

	; restaurer motif
	(gimp-context-set-pattern old_pattern)	
	
	; restaurer antialias
	(gimp-context-set-antialias old_antialias)

	; restaurer sample-merged
	(gimp-context-set-sample-merged old_sample-merged)
	
	; restaurer sample-criterion
	(gimp-context-set-sample-criterion old_sample-criterion)
	
	; restaurer sample-transparent		
	(gimp-context-set-sample-transparent old_sample-transparent)
	
	; restaurer sample-threshold-int		
	(gimp-context-set-sample-threshold-int old_sample-threshold-int)

	; restaurer interpolation
	(gimp-context-set-interpolation old_interpolation)
    
	; ne rien slectionner
	;(gimp-selection-none img)
	
	; afficher l'image
	(gimp-display-new img)


	;; End undo group.
	(gimp-image-undo-group-end img)	

	)
		
)

(script-fu-register
	"Demo_Texte_Metal_GMIC_Gimp"
	"<Image>/File/Create/Logos/G'MIC Demo Texte Metal..."
	"Demo. - Effets Texte Metal Avec GMIC"
	"samj"
	"samj"
	"2012-09-26"
	""
	SF-STRING	"Text " "GIMP 2.8"											; Texte
	SF-FONT "Font " "Serif Bold"											; Serif Bold   Police
	SF-ADJUSTMENT "Font Size [pixels] " '(128 64 480 1 10 0 1)		; Taille_Police
	SF-COLOR "Text Color" '(248 180 70) 							; f8b446
	SF-TOGGLE "Invert text color" FALSE
	SF-ADJUSTMENT "Noise"  '(22 0 200 1 10 0 1)
	SF-COLOR "Outline text color" '(248 180 70) 			; f8b446
	SF-TOGGLE "Invert outline text color" FALSE
	SF-ADJUSTMENT "Thickness contours"  '(2 0 8 1 2 0 1) 		; pixels
	SF-COLOR "Background color" '(7 75 185) 							; 074bb9
	SF-TOGGLE "Invert background color" FALSE
	SF-TOGGLE "Flatten" FALSE

	
)

; FIN du script

