; Dbut du script-fu Demo_Texte_3D_GMIC_gimp_2_8.scm
;
; Accs par :   Fichier > Crer > Logos > G'MIC Demo_Texte_3D...
;               File > Create > Logos > G'MIC Demo_Texte_3D...
;
;
;
;
;
; Licence GNU/GPL
;
; --------------------------------------------------------------------
; dit avec Notepad++    http://notepad-plus-plus.org/
;
; version 1.0 par samj (  http://www.aljacom.com/~gimp       http://samjcreations.blogspot.com  ) 9 juillet 2012
; version 1.01 par samj  ajout "Affichage des valeurs / Value Display" 16 juillet 2012
; version 1.02 par samj  ajout mode superposition (overlay) sur une ide de Rod 16 juillet 2012
;
; --------------------------------------------------------------------
;
;

;





(define (
				
				Demo_Texte_3D_GMIC_gimp_2_8
				Texte
				Police
				Taille_Police
				Depth_gimp_extrude3d			 ; de 1  20		; Depth = float(10,1,1024)
				Smoothness_gimp_extrude3d		 ; de0  3			; Smoothness = float(0.6,0,3)
				Y_angle_gimp_extrude3d			 ; de 0  60		; Y-angle = float(41,0,360)
				FOV_gimp_extrude3d				 ; de 1  90		; FOV = float(45,1,90)
				X_light_gimp_extrude3d			 ; de -100  + 100	; X-light = float(0,-100,100)
				Shininess_gimp_extrude3d		 ; de 0  3			; Shininess = float(0.7,0,3)
				Choix_Rendering_gimp_extrude3d
				Symetrie
				Couleur_texte
				Degrade
				Rendu_du_texte
				Calque_visible
				Valeurs_aleatoires
				Affichage_des_valeurs
				flatten				

		)



		
	(let*
		(
			; affectation des variables	

			; mmoriser les couleurs PP et AP
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
			
			; mmoriser la brosse active
			(old-brush (car (gimp-context-get-brush)))	

			; mmoriser le dgrad actif
			(old_gradient (car (gimp-context-get-gradient)))

			; mmoriser le motif actif
			(old_pattern (car (gimp-context-get-pattern)))

			; mmoriser antialias
			(old_antialias (car (gimp-context-get-antialias)))

			; mmoriser sample-merged
			(old_sample-merged (car (gimp-context-get-sample-merged)))
			
			; mmoriser sample-criterion
			(old_sample-criterion (car (gimp-context-get-sample-criterion)))
			
			; mmoriser sample-transparent		
			(old_sample-transparent (car (gimp-context-get-sample-transparent)))
			
			; mmoriser sample-threshold-int
			(old_sample-threshold-int (car (gimp-context-get-sample-threshold-int)))

			; mmoriser l'interpolation
			(old_interpolation (car (gimp-context-get-interpolation)))
			
			

			; caractristiques de la surface occupe par le texte
			(fond_texte)

			; largeur de la future image
			(width) 
			
			; hauteur de la future image
			(height) 
			
			; crer une nouvelle image rgb
			(img)
			
			; calques texte
			(calque_texte)
			
			; calques texte 2
			(calque_texte_2)
			
			; calque_couleur
			(calque_couleur)
			
			; calque_degrade
			(calque_degrade)
			
			; calque_plasma
			(calque_plasma)
			
			; calque_fond
			(calque_fond)


			;(Depth_gimp_extrude3d)					; de 1  20			; Depth = float(10,1,1024)
			(Resolution_gimp_extrude3d 512)		 						; Resolution = int(512,1,1024)
			;(Smoothness_gimp_extrude3d)			; de0  13			; Smoothness = float(0.6,0,3)
			(Width_gimp_extrude3d)			 							; Width = _int(1024,1,4096)
			(Height_gimp_extrude3d)			 							; Height = _int(1024,1,4096)
			(Size_gimp_extrude3d 0.7)			 						; Size = float(0.5,0,3)
			(X_angle_gimp_extrude3d 0)			 						; X-angle = float(57,0,360)
			;(Y_angle_gimp_extrude3d)				; de 0  60			; Y-angle = float(41,0,360)
			(Z_angle_gimp_extrude3d 0)			 						; Z-angle = float(21,0,360)
			;(FOV_gimp_extrude3d)					; de 1  90			; FOV = float(45,1,90)
			;(X_light_gimp_extrude3d)				; de -100  + 100	; X-light = float(0,-100,100)
			(Y_light_gimp_extrude3d -100)								; Y-light = float(0,-100,100)
			(Z_light_gimp_extrude3d -100)			 					; Z-light = float(-100,-100,0)
			(Specularity_gimp_extrude3d 0.5)		 					; Specularity = float(0.5,0,1)
			;(Shininess_gimp_extrude3d)				; de 0  3			; Shininess = float(0.7,0,3)
			(Rendering_gimp_extrude3d)				; 2 / 4 / 5			; Rendering = choice(4,"Dots","Wireframe","Flat","Flat shaded","Gouraud","Phong")
			

			
		)

	; vrification texte vide
	(if (= (string-length Texte) 0)
		(set! Texte "GIMP & GMIC")
	)

	
	
	
	; contexte
	(gimp-context-set-feather FALSE)
	
	(gimp-context-set-feather-radius 
		1									; feather-radius-x 
		1									; feather-radius-y
	)
	
	(gimp-context-set-antialias TRUE)

	(gimp-context-set-sample-merged TRUE)
	
	(gimp-context-set-sample-criterion 0) ;  (0 <= sample-threshold <= 1)
	
	(gimp-context-set-sample-transparent TRUE)
	
	(gimp-context-set-sample-threshold-int 1)
	
	(gimp-context-set-interpolation 2) ; interpolation cubique
	
	
	
	

	; valeurs alatoires
	(if
		(= Valeurs_aleatoires TRUE)
			(begin

				(set! Police (list-ref (cadr (gimp-fonts-get-list "")) (round (random (car (gimp-fonts-get-list "")))))	)
				(set! Taille_Police (round (+ (random (- 256 127)) 128)))
				(set! Depth_gimp_extrude3d (round (+ (random 30) 1)))				
				(set! Smoothness_gimp_extrude3d (/ (random 751) 1000))
				(set! Y_angle_gimp_extrude3d (/ (random 6001) 100))
				(set! FOV_gimp_extrude3d (+ 1 (/ (random 9000) 100)))
				(set! X_light_gimp_extrude3d (/ (- (random 20001) 10000) 100))
				(set! Shininess_gimp_extrude3d (/ (random 301) 100))
				(set! Choix_Rendering_gimp_extrude3d (round (random 3)))	
				(set! Symetrie (round (random 2)))
				(set! Couleur_texte (list (random 256) (random 256) (random 256)) )
				(set! Degrade (list-ref (cadr (gimp-gradients-get-list "")) (round (random (car (gimp-gradients-get-list "")))))	)
				(set! Rendu_du_texte (round (random 3)))
				(set! Calque_visible (round (random 4)))
				

			)		
	)


	; caractristiques de la surface occupe par le texte
	(set! fond_texte (gimp-text-get-extents-fontname Texte Taille_Police 0 Police))

	; largeur de la future image
	(set! width (car fond_texte)) 
	
	; hauteur de la future image
	(set! height (cadr fond_texte)) 
	
	; crer une nouvelle image rgb
	(set! img (car (gimp-image-new (+ width height) (+ width height) 0)))	
	

		
	;; Start undo group.
	(gimp-image-undo-group-start img)	


	; vrifications
	(if
		(= Affichage_des_valeurs TRUE)
			(begin

				(gimp-message 
					(strcat 
						"Dimensions : "  (number->string  width ) "|" (number->string  height )    
						"\n\rNb car. : "  (number->string  (string-length Texte)  )   
						"\n\rPolice : " Police
						"\n\rTaille_Police : "  (number->string  Taille_Police )
						"\n\rDepth_gimp_extrude3d : "  (number->string  Depth_gimp_extrude3d )	
						"\n\rSmoothness_gimp_extrude3d : "  (number->string  Smoothness_gimp_extrude3d )
						"\n\rY_angle_gimp_extrude3d : "  (number->string  Y_angle_gimp_extrude3d )
						"\n\rFOV_gimp_extrude3d : "  (number->string  FOV_gimp_extrude3d )
						"\n\rX_light_gimp_extrude3d : "  (number->string  X_light_gimp_extrude3d )
						"\n\rShininess_gimp_extrude3d : "  (number->string  Shininess_gimp_extrude3d )	
						"\n\rChoix_Rendering_gimp_extrude3d : "  (number->string  Choix_Rendering_gimp_extrude3d )
						"\n\rDegrade : " Degrade 
						"\n\rRendu_du_texte : "  (number->string  Rendu_du_texte )	
						"\n\rCalque_visible : "  (number->string  Calque_visible )						
					)  
				)
			)
	)



	

; calque Texte *******************************************************************************	

	; choisir pp
	(gimp-context-set-foreground '(0 0 0))

	; couleur d'arrire plan
	(gimp-context-set-background '(255 255 255))
	
	; crer le calque texte
	;                      (gimp-text-fontname image drawable x y text border antialias size size-type fontname)
	(set! calque_texte (car (gimp-text-fontname img -1 (/ height 2) (/ width 2) Texte 0 FALSE Taille_Police 0 Police)))

	; donner un nom au calque
	(gimp-item-set-name calque_texte "Texte")

	; calque texte aux dimensions de l'image
	(gimp-layer-resize-to-image-size calque_texte)
	

	
	; Symtrie
	(if
		(= Symetrie TRUE)
			(gimp-item-transform-flip-simple calque_texte 0 TRUE (/ (car (gimp-drawable-width calque_texte)) 2))
	)
	
	; prparer les variables pour G'MIC	
	(set! Depth_gimp_extrude3d (round (* 100 Depth_gimp_extrude3d)))				; de 1  20			; Depth = float(10,1,1024)
	(set! Resolution_gimp_extrude3d 1024)											; Resolution = int(512,1,1024)
	(set! Smoothness_gimp_extrude3d (round (* 100 Smoothness_gimp_extrude3d)))		; de0  13			; Smoothness = float(0.6,0,3)
	; respecter limite G'MIC
	(if
		(> (round (+ width height)) 4096)
			(begin
				(set! Width_gimp_extrude3d 4096)									; Width = _int(1024,1,4096)
				(set! Height_gimp_extrude3d 4096)									; Height = _int(1024,1,4096)
			)
			;else
			(begin
				(set! Width_gimp_extrude3d (round (+ width height)))					; Width = _int(1024,1,4096)
				(set! Height_gimp_extrude3d (round (+ width height)))				; Height = _int(1024,1,4096)
			)
	)

	
	(set! Size_gimp_extrude3d (round (* 100 Size_gimp_extrude3d)))					; Size = float(0.5,0,3)
	(set! X_angle_gimp_extrude3d (round (* 100 X_angle_gimp_extrude3d)))			; X-angle = float(57,0,360)
	(set! Y_angle_gimp_extrude3d (round (* 100 Y_angle_gimp_extrude3d)))			; de 0  60			; Y-angle = float(41,0,360)
	(set! Z_angle_gimp_extrude3d (round (* 100 Z_angle_gimp_extrude3d)))			; Z-angle = float(21,0,360)
	(set! FOV_gimp_extrude3d (round (* 100 FOV_gimp_extrude3d)))					; de 1  90			; FOV = float(45,1,90)
	(set! X_light_gimp_extrude3d (round (* 100 X_light_gimp_extrude3d)))			; de -100  + 100	; X-light = float(0,-100,100)
	(set! Y_light_gimp_extrude3d (round (* 100 Y_light_gimp_extrude3d)))			; Y-light = float(0,-100,100)
	(set! Z_light_gimp_extrude3d (round (* 100 Z_light_gimp_extrude3d)))			; Z-light = float(-100,-100,0)
	(set! Specularity_gimp_extrude3d (round (* 100 Specularity_gimp_extrude3d)))	; Specularity = float(0.5,0,1)
	(set! Shininess_gimp_extrude3d (round (* 100 Shininess_gimp_extrude3d)))		; de 0  3			; Shininess = float(0.7,0,3)
	;(Rendering_gimp_extrude3d)			; 2 / 4 / 5			; Rendering = choice(4,"Dots","Wireframe","Flat","Flat shaded","Gouraud","Phong")		
	(set! Rendering_gimp_extrude3d (+ Choix_Rendering_gimp_extrude3d 3))

	

	
	; Appel de gimp_extrude3d + remove_hotpixels dans G'MIC 		;"-gimp_extrude3d 10,512,0.60,512,512,0.7,0,45,0,45,6.61,-100,-100,0.5,0.7,4"
	(plug-in-gmic 1 img calque_texte 1
		(string-append
			"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
			"-gimp_extrude3d {"
			(number->string Depth_gimp_extrude3d 10)"/100},"
			(number->string Resolution_gimp_extrude3d 10)",{"
			(number->string Smoothness_gimp_extrude3d 10)"/100},"
			(number->string Width_gimp_extrude3d 10)","
			(number->string Height_gimp_extrude3d 10)",{"
			(number->string Size_gimp_extrude3d 10)"/100},{"
			(number->string X_angle_gimp_extrude3d 10)"/100},{"
			(number->string Y_angle_gimp_extrude3d 10)"/100},{"
			(number->string Z_angle_gimp_extrude3d 10)"/100},{"
			(number->string FOV_gimp_extrude3d 10)"/100},{"
			(number->string X_light_gimp_extrude3d 10)"/100},{"
			(number->string Y_light_gimp_extrude3d 10)"/100},{"
			(number->string Z_light_gimp_extrude3d 10)"/100},{"
			(number->string Specularity_gimp_extrude3d 10)"/100},{"
			(number->string Shininess_gimp_extrude3d 10) "/100},"
			(number->string Rendering_gimp_extrude3d 10)
			" -remove_hotpixels "
			(number->string (round (+ 0.5 (/ (car (gimp-drawable-width calque_texte)) 100))) 10)",10"
		)
	)	


	; contenu vers slection , existe-t-il un quivalent pour Gimp 2.8 ???
	(gimp-selection-layer-alpha calque_texte)
	
	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img calque_texte)
	
	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "contour_extrude3d")

	; ne rien slectionner
	(gimp-selection-none img)	
	
	
	
	
	
	
	
	
; calque Texte 2 *******************************************************************************	
	
	; calque avec effet des filtres
	(set! calque_texte_2 (car (gimp-layer-copy calque_texte TRUE)))
	
	; ajouter le calque calque_texte_2
	(gimp-image-insert-layer img calque_texte_2 0 -1)

	; donner un nom au calque
	(gimp-item-set-name calque_texte_2 "Texte_2")
	
	; rendre le calque actif ( vrifier pour G'MIC)
	(gimp-image-set-active-layer img calque_texte_2)
		
	; ajouter du flou gaussien
;	(plug-in-gauss 
;		1				; run-mode 
;		img				; image 
;		calque_texte_2	; drawable 
;		(round (+ 0.5 (/ (car (gimp-drawable-width calque_texte_2)) 1600)))				; horizontal 
;		(round (+ 0.5 (/ (car (gimp-drawable-width calque_texte_2)) 1600)))				; vertical 
;		1				; method
;	)


	(if
		(= Rendu_du_texte 0)
			; Appel de gimp_ink_wash dans G'MIC
			(plug-in-gmic 1 img calque_texte_2 1
				(string-append
					"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
					"-gimp_ink_wash 0.14,23,0,0.5,0.54,2.25,0,2,6,5,20"
				)
			)
	)


	(if
		(= Rendu_du_texte 1)
			(begin
				; Appel de gimp_contrast_swm dans G'MIC
				(plug-in-gmic 1 img calque_texte_2 1
					(string-append
						"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
						"-gimp_contrast_swm "
						(number->string (round (+ 1.5 (/ (car (gimp-drawable-width calque_texte_2)) 100))) 10)",0,0"
					)
				)
				
				; ajouter du flou gaussien
				(plug-in-gauss 
					1				; run-mode 
					img				; image 
					calque_texte_2	; drawable 
					(round (+ 0.5 (/ (car (gimp-drawable-width calque_texte_2)) 1600)))	; horizontal 
					(round (+ 0.5 (/ (car (gimp-drawable-width calque_texte_2)) 1600)))	; vertical 
					1				; method
				)
				
				; renforcer la nettet
				(plug-in-unsharp-mask 
					1				; run-mode 
					img				; image 
					calque_texte_2	; drawable 
					(round (+ 0.5 (/ (car (gimp-drawable-width calque_texte_2)) 200)))	; radius 
					0.5				; amount 
					0				; threshold
				)
			)
	)
	
	



	
	
	; ajuster les dimensions 
	(plug-in-autocrop 1 img calque_texte_2)


	; Symtrie
	(if
		(= Symetrie TRUE)
			(gimp-item-transform-flip-simple calque_texte_2 0 TRUE (/ (car (gimp-drawable-width calque_texte_2)) 2))
	)


	


; calque_fond*********************************************************************************
	

	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new img (car (gimp-drawable-width calque_texte_2)) (car (gimp-drawable-height calque_texte_2)) 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer img calque_fond 0 -1)

	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_texte)
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background '(255 255 255))

	; remplir de PP	
	(gimp-drawable-fill calque_fond 0)	



	
; calque_couleur*********************************************************************************
	

	; crer calque_couleur
	(set! calque_couleur (car (gimp-layer-new img (car (gimp-drawable-width calque_texte_2)) (car (gimp-drawable-height calque_texte_2)) 1 "calque_couleur" 100 0)))	
	
	; ajouter le calque calque_couleur
	(gimp-image-insert-layer img calque_couleur 0 -1)

	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_texte)
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background '(255 255 255))

	; remplir de PP	
	(gimp-drawable-fill calque_couleur 0)	

	; mettre le calque en mode couleur
	(gimp-layer-set-mode calque_couleur 13)
	
	

; calque_degrade*********************************************************************************
	
	

	; crer calque_degrade
	(set! calque_degrade (car (gimp-layer-new img (car (gimp-drawable-width calque_texte_2)) (car (gimp-drawable-height calque_texte_2)) 1 "calque_degrade" 100 0)))	
	
	; ajouter le calque calque_degrade
	(gimp-image-insert-layer img calque_degrade 0 -1)

	; modifier couleur de premier plan
	(gimp-context-set-foreground '(0 0 0))
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background '(255 255 255))

	; slectionner le dgrad choisi
	(gimp-context-set-gradient Degrade)
	
	; appliquer un dgrad sur calque calque_degrade
	(gimp-edit-blend 
		calque_degrade 
		3 						; MODE
		0 
		0 						; GRADIENT-LINEAR
		100 
		0 
		0 
		FALSE 
		TRUE 
		3 
		2 
		FALSE
		0												; x1 
		(/ (car (gimp-drawable-height calque_texte_2)) 2)	; y1 
		(car (gimp-drawable-width calque_texte_2))		; x2
		(/ (car (gimp-drawable-height calque_texte_2)) 2)	; y2
	)


	; mettre le calque en mode couleur
	(gimp-layer-set-mode calque_degrade 13)
	
	
	
	
	
	
; calque_plasma*********************************************************************************
	
	

	; crer calque_plasma
	(set! calque_plasma (car (gimp-layer-new img (car (gimp-drawable-width calque_texte_2)) (car (gimp-drawable-height calque_texte_2)) 1 "calque_plasma" 100 0)))	
	
	; ajouter le calque calque_plasma
	(gimp-image-insert-layer img calque_plasma 0 -1)

	; Appel de gimp_plasma dans G'MIC
	(plug-in-gmic 1 img calque_plasma 1
		(string-append
			"-v - " ; To have a silent output. Remove it to display errors from the G'MIC interpreter on stderr.
			"-gimp_plasma 0.5,0,8,0,0,128,128,128"
		)
	)	

	; mettre le calque en mode couleur
	(gimp-layer-set-mode calque_plasma 13)

	

	
	
	
; visibilit et positionnement des calques*********************************************************



	; uniquement le calque couleur en mode color
	(if
		(= Calque_visible 0)
			(begin
				; mettre la visibilit des calques
				(gimp-layer-set-visible calque_couleur TRUE)	
				(gimp-layer-set-visible calque_degrade FALSE)
				(gimp-layer-set-visible calque_plasma FALSE)				
			)
	)
	
	; uniquement le calque dgrad en mode color
	(if
		(= Calque_visible 1)
			(begin
				; mettre la visibilit des calques
				(gimp-layer-set-visible calque_couleur FALSE)	
				(gimp-layer-set-visible calque_degrade TRUE)
				(gimp-layer-set-visible calque_plasma FALSE)				
			)
	)

		; uniquement le calque plasma en mode color
	(if
		(= Calque_visible 2)
			(begin
				; mettre la visibilit des calques
				(gimp-layer-set-visible calque_couleur FALSE)	
				(gimp-layer-set-visible calque_degrade FALSE)
				(gimp-layer-set-visible calque_plasma TRUE)				
			)
	)
	
	; Calque couleur en mode color et calque dgrad en mode overlay
	(if
		(= Calque_visible 3)
			(begin
				; mettre la visibilit des calques
				(gimp-layer-set-visible calque_couleur TRUE)	
				(gimp-layer-set-visible calque_degrade TRUE)
				(gimp-layer-set-visible calque_plasma FALSE)

				; mettre le calque en mode Overlay
				(gimp-layer-set-mode calque_degrade 5)			
			)
	)
	
	
	
	(gimp-layer-set-visible calque_fond FALSE)
	
	; mettre le calque au bas de la pile
	(gimp-image-lower-item-to-bottom img calque_fond)


	; ajuster les dimensions 
	(plug-in-autocrop 1 img calque_texte)
	
	(gimp-layer-set-visible calque_texte FALSE)	
	
	
	
	
;*******************************************************************************************
	
	; aplatir l'image
	(if
		(= flatten TRUE)
			(gimp-image-flatten img)
	)	
	
	
	
;*****************************************************************************************	
	
	
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg)
	(gimp-context-set-background old-bg)
	
	; restaurer ancien dgrad
	(gimp-context-set-gradient old_gradient)
	
	; restaurer brosse
	(gimp-context-set-brush old-brush)

	; restaurer motif
	(gimp-context-set-pattern old_pattern)	
	
	; restaurer antialias
	(gimp-context-set-antialias old_antialias)

	; restaurer sample-merged
	(gimp-context-set-sample-merged old_sample-merged)
	
	; restaurer sample-criterion
	(gimp-context-set-sample-criterion old_sample-criterion)
	
	; restaurer sample-transparent		
	(gimp-context-set-sample-transparent old_sample-transparent)
	
	; restaurer sample-threshold-int		
	(gimp-context-set-sample-threshold-int old_sample-threshold-int)

	; restaurer interpolation
	(gimp-context-set-interpolation old_interpolation)
    
	; ne rien slectionner
	(gimp-selection-none img)
	
	; afficher l'image
	(gimp-display-new img)


	;; End undo group.
	(gimp-image-undo-group-end img)	

	)
		
)

(script-fu-register
	"Demo_Texte_3D_GMIC_gimp_2_8"
	"<Image>/File/Create/Logos/G'MIC Text 3D..."
	"Demo. - Effets De Texte 3D Avec GMIC"
	"samj"
	"samj"
	"2012-07-09"
	""
	SF-STRING	"Text " "GIMP 2.8"											; Texte
	SF-FONT "Font " "Serif Bold"											; Serif Bold   Police
	SF-ADJUSTMENT "Font Size [pixels] " '(128 64 480 1 10 0 1)		; Taille_Police
	SF-ADJUSTMENT "Depth (extrude3d) " '(10 1 30 1 10 2 2)				; Depth_gimp_extrude3d			; de 1  30			; Depth = float(10,1,1024)
	SF-ADJUSTMENT "Smoothness (extrude3d) " '(0.5 0 0.75 0.05 0.2 2 2)	; Smoothness_gimp_extrude3d		; de 0  0.75		; Smoothness = float(0.6,0,3)
	SF-ADJUSTMENT "Y-angle (extrude3d) " '(45 0 60 1 10 2 2)						; Y-angle_gimp_extrude3d		; de 0  60			; Y-angle = float(41,0,360)
	SF-ADJUSTMENT "FOV (extrude3d) " '(45 1 90 1 10 2 2)			; FOV_gimp_extrude3d			; de 1  90			; FOV = float(45,1,90)
	SF-ADJUSTMENT "X-light (extrude3d) " '(0 -100 100 1 10 2 2)			; X-light_gimp_extrude3d		; de -100  + 100	; X-light = float(0,-100,100)
	SF-ADJUSTMENT "Shininess (extrude3d) " '(0.7 0 3 0.1 1 2 2)			; Shininess_gimp_extrude3d		; de 0  3			; Shininess = float(0.7,0,3)
	SF-OPTION "Filter Rendering (extrude3d) " '(" Flat shaded " " Gouraud " " Phong " )	; Choix_Rendering_gimp_extrude3d choice(4,"Dots","Wireframe","Flat","Flat shaded","Gouraud","Phong")
	SF-TOGGLE "Symmetry " FALSE
	SF-COLOR "Text Color" '(191 141 7) 								; bf8d07
	SF-GRADIENT "Gradient " "Metallic Something"  						; Degrade_du_calque_gradient
	SF-OPTION "Text Rendering " '(" Metallic Colors " " Little Reflection " " Without Reflection " )
	SF-OPTION "Visible Layer " '(" Color (Mode: Color) " " Gradient (Mode: Color) " " Plasma (Mode: Color) " " Color & Gradient (Modes: Color & Overlay)" )
	SF-TOGGLE "Random Values" FALSE
	SF-TOGGLE "Value Display" FALSE	
	SF-TOGGLE "Flatten" FALSE
	
)

; FIN du script

